#include "bits/stdc++.h"
#include "testlib.h"
#define puba push_back
#define mapa make_pair
#define ff first
#define ss second
#define bend(_x) begin(_x), end(_x)
#define szof(_x) ((int) (_x).size())
#define TASK_NAME ""

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const double PI = atan2(0, -1);
const int MAXN = 500, MAXW = 1000000000;

int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);

    assert(argc >= 3);

    int k = atoi(argv[1]);
    int n = atoi(argv[2]);

    cout << n << " " << k << "\n";
    
    map<pii, int> where;
    for (int i = 0; i < n; ++i) {
        int lvl = (int) sqrt(rnd.next(1ll, (ll) k * k));
        int type = rnd.next(0, 3);
        if (where[{lvl, type}] == lvl * 2 - 1) {
            --i;
            continue;
        }
        where[{lvl, type}]++;
    }

    vector<pair<pii, pii>> outp;

    for (auto p : where) {
        vector<int> v1, v2;
        if (p.ss > p.ff.ff / 4) {
            for (int i = 0; i < p.ff.ff * 2; ++i) {
                v1.puba(i);
            }
            for (int i = 0; i <= p.ff.ff * 2 - 2; ++i) {
                v2.puba(i + 1);
            }
            shuffle(bend(v1));
            v1.resize(p.ss);
            sort(bend(v1));
            shuffle(bend(v2));
            v2.resize(p.ss);
            sort(bend(v2));
        } else {
            set<int> s1, s2;
            for (int i = 0; i < p.ss; ++i) {
                while (true) {
                    int tmp = rnd.next(0, p.ff.ff * 2 - 1);
                    if (!s1.count(tmp)) {
                        s1.insert(tmp);
                        break;
                    }
                }
                while (true) {
                    int tmp = rnd.next(1, p.ff.ff * 2 - 1);
                    if (!s2.count(tmp)) {
                        s2.insert(tmp);
                        break;
                    }
                }
            }
            for (int num : s1) {
                v1.puba(num);
            }
            for (int num : s2) {
                v2.puba(num);
            }
        }

        for (int i = 0; i < szof(v1); ++i) {
           pair<pii, pii> e;
           if (p.ff.ss == 0) {
               e = {{p.ff.ff, v1[i] - p.ff.ff}, {p.ff.ff - 1, v2[i] - p.ff.ff}};
           } else if (p.ff.ss == 1) {
               e = {{-(v1[i] - p.ff.ff), -p.ff.ff}, {-(v2[i] - p.ff.ff), -p.ff.ff + 1}};
           } else if (p.ff.ss == 2) {
               e = {{-p.ff.ff, -(v1[i] - p.ff.ff)}, {-p.ff.ff + 1, -(v2[i] - p.ff.ff)}};
           } else {
               e = {{v1[i] - p.ff.ff, p.ff.ff}, {v2[i] - p.ff.ff, p.ff.ff - 1}};
           }         
           if (rnd.next(0, 1)) {
                swap(e.ff, e.ss);
           }
           outp.puba(e);
        }
    }

    shuffle(bend(outp));
    for (auto e : outp) {
        cout << e.ff.ff << " " << e.ff.ss << " " << e.ss.ff << " " << e.ss.ss << "\n";
    }

    const int MAXC = 1000000000;

    int xa = rnd.next(k + 1, MAXC) * (rnd.next(0, 1) * 2 - 1);
    int ya = rnd.next(k + 1, MAXC) * (rnd.next(0, 1) * 2 - 1);
    int xb = rnd.next(-k, k);
    int yb = rnd.next(-k, k);

    assert(argc >= 4);
    if (atoi(argv[3])) {
        swap(xa, xb);
        swap(ya, yb);
    }

    cout << xa << " " << ya << " " << xb << " " << yb << "\n";

    return 0;
}