from sys import *
from random import *


def ln(have, want, mod):
    if have == want:
        return 0
    a1 = (want - have) % mod
    return len(str(a1))


def get(have, want, mod):
    if have == want:
        return None
    a1 = (want - have) % mod
    return '+', str(a1)


def rnd(len):
    s = []
    for i in range(len):
        s.append(randint(0, 9))
    return ''.join(map(str, s))


def gen_part(size, ans, mod):
    res = []
    sgns = []
    sz = 0
    cur = 0
    if ln(0, ans, mod) > size:
        return None

    lns = []
    for i in range(size):
        ind = randint(0, len(lns))
        if ind == len(lns):
            lns.append(1)
        else:
            lns[ind] += 1

    for i in range(len(lns)):
        cs = '+'
        res.append(rnd(lns[i]))

        cur += int(res[-1])

        cur %= mod
        sz += len(res[-1])

        sgns.append(cs)

    while sz + ln(cur, ans, mod) > size:
        sz -= len(res[-1])
        cur -= int(res[-1])
        cur %= mod
        res.pop()
        sgns.pop()

    for i in range(len(res)):
        res[i] = (sgns[i], res[i])

    x = get(cur, ans, mod)
    if x is not None:
        res.append(x)

    if len(res) == 0:
        res.append(('+', '0'))

    shuffle(res)
    return res


def gen_random(SZ, K, MOD):
    a = [randint(0, 9) for i in range(SZ)]
    k = K
    print(SZ, k - 1, MOD, 2)
    print(''.join(map(str, a)))


def gen_test(SZ, K, MOD):
    gen_random(SZ, K, MOD)


OKS, RANDS = int(argv[1]), int(argv[2])
SZ = int(argv[3])
K = int(argv[4])
MOD = int(argv[5])
seed(argv[6])

print(OKS + RANDS)
for i in range(OKS + RANDS):
    if randint(1, OKS + RANDS) <= RANDS:
        gen_random(SZ, K, MOD)
        RANDS -= 1
    else:
        gen_test(SZ, K, MOD)
        OKS -= 1
